/* --------------------------------------------------------- */
/*	Font Editor												 */
/* ========================================================= */
/*	2006/02/11	t.hara										 */
/* --------------------------------------------------------- */

#include <iostream>
#include <fstream>
#include <iomanip>

using namespace std;

/* --------------------------------------------------------- */
int main( int argc, char *argv[] ) {
	unsigned short font[ 8 ];
	char buffer[ 256 ];

	if( argc < 3 ) {
		cout << "Usage> " << argv[0] << " <in> <out>" << endl;
		return 1;
	}

	ifstream in_file( argv[1] );
	if( in_file == 0 ) {
		cout << "cannot open file." << endl;
		return 2;
	}
	ofstream out_file( argv[2] );
	if( out_file == 0 ) {
		cout << "cannot create file." << endl;
		return 3;
	}

	for( int code = 0; code < 128; code++ ) {
		/* Pǂݍ */
		for( int row = 0; row < 16; row++ ) {
			/* Psǂݍ */
			in_file.getline( buffer, sizeof(buffer) );
			for( int col = 0; col < 8; col++ ) {
				font[ col ] = (font[ col ] << 1) | ( buffer[ col ] == 'X' );
			}
		}
		out_file << "\t{ ";
		for( int row = 0; row < 8; row++ ) {
			out_file << "0x" << setw( 4 ) << hex << setfill( '0' ) << font[ row ] << ", ";
		}
		out_file << "}," << endl;
	}
}
