/* --------------------------------------------------------- */
/*	BASIC-E GRAPHIC layer									 */
/*	Copyright(C)2006 t.hara									 */
/* ========================================================= */
/*	graphic screen layer									 */
/* --------------------------------------------------------- */

#ifndef __GRAPHIC_LAYER_H__
#define __GRAPHIC_LAYER_H__

class c_graphic_layer {
private:
	int	width;
	int	height;
	unsigned short *p_image;

public:
	c_graphic_layer( void ): width(0), height(0), p_image(0) {
	}
	
	~c_graphic_layer() {
	}

	void create( int width, int height ) {
		release();
		p_image = new unsigned short [ width * height ];
	}

	void release( void ) {
		delete[] p_image;
		p_image = 0;
	}
};

/* (MSB) {rrrrrggggggbbbbb} (LSB)	*/
#define rgb_color( r, g, b )	( ((b) & 31) | (((g) & 63) << 5) | (((r) & 31) << 11) )

#endif
